#!/bin/bash
### BEGIN INIT INFO
# Provides:          rk_testinternet
# Required-Start:    
# Required-Stop:     
# Default-Start:     
# Default-Stop:      
# Short-Description: testuje pripojenie k internetu a ak hodinu nieje spojenie, tak sa nachvilu vypne napajanie FritzBoxu
# Description:       
#                    
# END INIT INFO
# Author: Richard Kaliciak <richard.kaliciak@freenet.de>
#
# Do NOT "set -e"

# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/sbin:/usr/sbin:/bin:/usr/bin:/usr/local/bin
# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh
# Define LSB log_* functions.
# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
. /lib/lsb/init-functions

# aktivovanie vypisov pre DEBUG=1
DEBUG=1
LINENUMBER=0

if [ $DEBUG -eq 1 ]; then
	echo Anfang
	date
fi

################ konstanty ################
WAITTIME=60
TESTIP=8.8.8.8
MAXFAIL=30
IP_FAIL=20

# +-----+-----+---------+------+---+---Pi 3---+---+------+---------+-----+-----+
# | BCM | wPi |   Name  | Mode | V | Physical | V | Mode | Name    | wPi | BCM |
# +-----+-----+---------+------+---+----++----+---+------+---------+-----+-----+
# |  27 |   2 | GPIO. 2 |  OUT | 0 | 13 || 14 |   |      | 0v      |     |     |
# +-----+-----+---------+------+---+----++----+---+------+---------+-----+-----+
PIN_RELE=2

if [ $DEBUG -eq 1 ]; then
	echo "WAITTIME=$WAITTIME"
	echo "TESTIP=$TESTIP"
	echo "MAXFAIL=$MAXFAIL"
	echo "IP_FAIL=$IP_FAIL"
	echo "PIN_RELE=$PIN_RELE"
fi

################ konstanty ################


CNT_OK=0
CNT_OK_ALL=0
CNT_FAIL=0
CNT_FAIL_ALL=0
CNT_RESET_ALL=0
CNT_RESTART_ALL=0

# opakuj donekonecna
# ukonci, ked najdes subor s menom stop
while [ ! -f ./stop ]
do 
    TEXTLINE=""
	# datum a cas
	TERAZ=$(date +%d.%m.%Y-%H:%M:%S)
    #echo $TERAZ
    TEXTLINE="$TEXTLINE $TERAZ"

    # testuj spojenie
    if ping -w 5 -c 1 $TESTIP > /dev/null; then
        CNT_OK=$((CNT_OK+1))
	CNT_OK_ALL=$((CNT_OK_ALL+1))
        CNT_FAIL=0
        PINGSTATUS="$CNT_OK. spojenie ku $TESTIP OK"
        
    else
        CNT_FAIL=$((CNT_FAIL+1))
	CNT_FAIL_ALL=$((CNT_FAIL_ALL+1))
        CNT_OK=0
        PINGSTATUS=" $TESTIP nedosiahnutelny"
        
    fi
    TEXTLINE="$TEXTLINE $PINGSTATUS"
    
    echo $TEXTLINE
    
    # pri dosiahnuti hranice IP_FAIL zresetuj eth0
    if [ $CNT_FAIL -eq $IP_FAIL ]; then
    	echo "spustam prikazy ifdown a ifup - start $TERAZ"
	CNT_RESTART_ALL=$((CNT_RESTART_ALL+1))
	sudo ifdown eth0 && sudo ifup eth0
	echo "spustam prikazy ifdown a ifup - end $(date +%d.%m.%Y-%H:%M:%S)"
    fi
    
    if [ $CNT_FAIL -ge $MAXFAIL ]; then
        CNT_FAIL=0
        echo "RESET! start $TERAZ"
	CNT_RESET_ALL=$((CNT_RESET_ALL+1))
	# zapnut rele na GPIOx
	gpio mode $PIN_RELE out
	gpio write $PIN_RELE 1
        sleep 10
        echo "RESET! end $(date +%d.%m.%Y-%H:%M:%S)"
	# vypnut rele na GPIOx
	gpio write $PIN_RELE 0
    fi
    
    sleep $WAITTIME
    
done

if [ $DEBUG -eq 1 ]; then
	echo ""
	echo "========================================"
	echo "aktualny stav:"
	echo "CNT_OK=$CNT_OK"
	echo "CNT_FAIL=$CNT_FAIL"
	echo "celkovy stav:"
	echo "CNT_OK_ALL=$CNT_OK_ALL"
	echo "CNT_FAIL_ALL=$CNT_FAIL_ALL"
	echo "CNT_RESTART_ALL=$CNT_RESTART_ALL"
	echo "CNT_RESET_ALL=$CNT_RESET_ALL"
	echo "========================================"
	echo ""
fi

# zmaz subor stop
if [ -f ./stop ]; then
    echo "mazem subor stop"
    rm ./stop
fi

if [ $DEBUG -eq 1 ]; then
	date
	echo Ende
fi

